﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace _33250A_Csharp_RS232
{
    class Program
    {
        static void Main(string[] args)
        {
            int RM;
            int FGEN;
            string id;
            string error;
            byte[] byteerror = new byte[256];
            byte[] byteid = new byte[100];
            
            visa32.viOpenDefaultRM(out RM);
            visa32.viOpen(RM, "ASRL1::INSTR", visa32.VI_NULL, 20000, out FGEN);

            visa32.viPrintf(FGEN, "*CLS\n");  //Clear buffer
            visa32.viPrintf(FGEN, "*RST\n");  //Reset Instrument
            visa32.viPrintf(FGEN, "*IDN?\n");  // Identify Instrument

            visa32.viScanf(FGEN, "%t", byteid);
            id = Encoding.ASCII.GetString(byteid);

            Console.WriteLine("Instrument Identity String: " + id);


            //Send commands to set the desired configuration
            visa32.viPrintf(FGEN, "FUNCTION SIN\n");        
            visa32.viPrintf(FGEN, "FREQUENCY 2000\n");
            visa32.viPrintf(FGEN, "VOLT:UNIT VPP\n");
            visa32.viPrintf(FGEN, "VOLT 2\n");
            visa32.viPrintf(FGEN, "VOLT:OFFSET 0\n");
            visa32.viPrintf(FGEN, "OUTPUT:LOAD 50\n");

            //Enable output.
            visa32.viPrintf(FGEN, "OUTPUT ON\n");

            //Check for errors
            visa32.viPrintf(FGEN, "SYST:ERR?\n");
            visa32.viScanf(FGEN, "%t", byteerror);
            error = Encoding.ASCII.GetString(byteerror);

            Console.WriteLine("Error Check: " + error);

            Console.WriteLine("\nPress any key to close...");
            Console.ReadLine();


            visa32.viClose(FGEN);
            visa32.viClose(RM);


        }
    }
}
